package com.aliyun.odps.spark.examples

import org.apache.spark.sql.SparkSession
import com.aliyun.odps.TableSchema
import com.aliyun.odps.data.Record
import com.google.common.collect.ListMultimap
import examples.dataloader.RecommendSampleConstructor
import org.apache.spark.aliyun.odps.OdpsOps

import java.util
import java.util.ArrayList

object makedata_01_readhdfs {
  def main(args: Array[String]) {
    val spark = SparkSession
      .builder()
      .appName("WordCount")
      .getOrCreate()
    val sc = spark.sparkContext

    val accessKeyId = "LTAIWYUujJAm7CbH"
    val accessKeySecret = "RfSjdiWwED1sGFlsjXv0DlfTnZTG1P"
    val odpsUrl = "http://service.odps.aliyun.com/api"
    val tunnelUrl = "http://dt.cn-hangzhou.maxcompute.aliyun-inc.com"
    println("Read odps table...")

    val project = "loghubods"
    val table = "alg_recsys_view_sample"
    val partition = "dt=20231218"


    val odpsOps = OdpsOps(sc, accessKeyId, accessKeySecret, odpsUrl, tunnelUrl)
    val odpsData = odpsOps.readTable(project = project, table = table, partition = partition, transfer = read, numPartition = 5)
    println(s"Count (odpsData): ${odpsData.count()}")

  }

  def read(record: Record, schema: TableSchema): Long = {
    val labelName = "share_ornot"
    val label = record.getString(labelName)
    val label_new = if (label == null || label == "1")
      0L
    else
      1L

    // 从sql的 record中 初始化对象内容
    val requestContext = RecommendSampleConstructor.constructRequestContext(record)
    val userFeature = RecommendSampleConstructor.constructUserFeature(record)
    val itemFeature = RecommendSampleConstructor.constructItemFeature(record)

    // 转化成bytes// 转化成bytes
    val requestContextBytesFeature = new Nothing(requestContext)
    val userBytesFeature = new Nothing(userFeature)
    val videoBytesFeature = new Nothing(itemFeature)

    // 特征抽取// 特征抽取
    var bytesFeatureExtractor: Nothing = null
    bytesFeatureExtractor = new Nothing

    bytesFeatureExtractor.getUserFeatures(userBytesFeature)
    bytesFeatureExtractor.getItemFeature(videoBytesFeature)
    bytesFeatureExtractor.getContextFeatures(requestContextBytesFeature)

    val featureMap = bytesFeatureExtractor.getFeatures
    return parseSamplesToString(label, featureMap)
  }

  def parseSamplesToString(label: String, featureMap: ListMultimap[FeatureGroup, BaseFeature]): String = {
    val featureList: util.ArrayList[String] = new util.ArrayList[String]
    import scala.collection.JavaConversions._
    for (entry <- featureMap.entries) {
      val groupedFeature: Nothing = entry.getKey
      val baseFeature: Nothing = entry.getValue
      val featureIdentifier: Long = baseFeature.getIdentifier
      featureList.add(String.valueOf(featureIdentifier) + ":1")
    }
    label + "\t" + String.join("\t", featureList)
  }
}